#include "PQDetectionSDKTool.h"
#include <stdio.h>
#include <Windows.h>

#pragma comment(lib, "PQDetectionSDKTool.lib")

void OnDetected(DetectionData detectionData)
{
	//show tags detail
	for (int i = 0; i < detectionData.tagsCount; i++)
	{
		printf("tagId: %d, \ttagType: %d, \ttagAction: %d, \tcX: %.2f, \tcY: %.2f\n", detectionData.tags[i].id, detectionData.tags[i].type, detectionData.tags[i].status, detectionData.tags[i].cx, detectionData.tags[i].cy);
	}
	//show objects detail
	for (int i = 0; i < detectionData.objectsCount; i++)
	{
		printf("eyesid: %d, \ttype: %d, \ttype_description: %s \tstatus: %d, \tcX: %.2f, \tcY: %.2f\n", detectionData.objects[i].id, detectionData.objects[i].type, detectionData.objects[i].type_description, detectionData.objects[i].status, detectionData.objects[i].cx, detectionData.objects[i].cy);
	}
	printf("-----------------------------------------------\r\n");
}
//
//// callback mode
//int main()
//{
//	int re = InitAndRun("127.0.0.1", 53607, CALLBACK_MODE, OnDetected);
//	if (re != 0)
//	{
//		printf("InitAndRun Error. Error code:%d\r\n", re);
//	}
//	getchar();
//	ShutdownAndRelease();
//}

// non callback mode
int main()
{
	int re = InitAndRun("127.0.0.1", 53607, DEFAULT_MODE, 0);
	if (re != 0)
	{
		printf("InitAndRun Error. Error code:%d\r\n", re);
		getchar();
		return re;
	}
	DEVICE_PLATFORM_INFO devInfo = {0};
	while (1)
	{
		if (GetPlatFormInfo(&devInfo) == 0)
		{
			printf("%s: w:%d h:%d\n", devInfo.SN, devInfo.w, devInfo.h);
			break;
		}
		else printf("error\n");
	}
	while (1)
	{
		DetectionData detectionData;
		re = ProcessDetectedData(&detectionData);
		if(re == 0)
			OnDetected(detectionData);
	}
	ShutdownAndRelease();
}