﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestSDK_CS
{
    class TestSDK_CS
    {
        static DetectionData m_detectionData;
        static void OnDetected(DetectionData detectionData)
        {
            for (int i = 0; i < detectionData.tagsCount; i++)
            {
                Console.WriteLine("tagId: {0}, \ttagType: {1}, \ttagAction: {2}, \tnX: {3:F2}, \tnY: {4:F2}", detectionData.tags[i].id, detectionData.tags[i].type, detectionData.tags[i].status, detectionData.tags[i].cx, detectionData.tags[i].cy);
            }
            for (int i = 0; i < detectionData.objectsCount; i++)
            {
                Console.WriteLine("eyesid: {0}, \ttype: {1}, \ttype_description: {2} \tstatus: {3}, \tnX: {4:F2}, \tnY: {5:F2}", detectionData.objects[i].id, detectionData.objects[i].type, Encoding.ASCII.GetString(detectionData.objects[i].type_description).Split('\0')[0], detectionData.objects[i].status, detectionData.objects[i].cx, detectionData.objects[i].cy);
            }
            //Console.WriteLine("-----------------------------------------------");
        }

        //static void Main(string[] args)
        //{
        //    PQDetectionSDKTool pqDetectionSDKTool = new PQDetectionSDKTool();
        //    int re = pqDetectionSDKTool.InitAndRunEx("127.0.0.1", 53607, GET_DETECTION_DATA_MODE.CALLBACK_MODE, OnDetected);

        //    if (re == 0)
        //    {
        //        Console.ReadKey();
        //    }
        //    else
        //    {
        //        Console.WriteLine("Init error.");
        //    }

        //    pqDetectionSDKTool.ShutdownAndReleaseEx();
        //    pqDetectionSDKTool = null;
        //}

        static void Main(string[] args)
        {
            PQDetectionSDKTool pqDetectionSDKTool = new PQDetectionSDKTool();
            int re = pqDetectionSDKTool.InitAndRunEx("127.0.0.1", 53607, GET_DETECTION_DATA_MODE.DEFAULT_MODE, null);
            if (re == 0)
            {
                DEVICE_PLATFORM_INFO info = default(DEVICE_PLATFORM_INFO);
             
                while (true)
                {
                    int bre = -1;
                    bre = pqDetectionSDKTool.GetPlatFormInfo(ref info);
                    if (bre == 0) break;
                }
                Console.WriteLine(info.SN + " " + info.w + " " + info.h);
                while (true)
                {
                    int re2 = pqDetectionSDKTool.ProcessDetectedFrameEx(ref m_detectionData);
                    if (re2 == 0)
                    {
                        OnDetected(m_detectionData);
                    }
                }
            }
            else
            {
                Console.WriteLine("Init error.");
            }
            pqDetectionSDKTool.ShutdownAndReleaseEx();
            pqDetectionSDKTool = null;
        }
    }
}
